import jwt
import bcrypt
from user_schema import User
from typing import Dict,List
from datetime import timedelta, datetime

TOKEN_EXPIRY=timedelta(minutes=15)
SECRET='change_secret'
ALGORITHM='HS256'

def refresh_token(token: str):
    decoded = None
    try:
        decoded = jwt.decode(token,SECRET,algorithms=[ALGORITHM])
    except jwt.ExpiredSignatureError as err:
        decoded = jwt.decode(token, SECRET, algorithms=[ALGORITHM], verify=False)
    decoded['exp'] = datetime.now()+ TOKEN_EXPIRY
    return jwt.encode(decoded, SECRET, algorithms=ALGORITHM)

def get_username(token: str): 
    decoded = None
    try:
        decoded = jwt.decode(token,SECRET,algorithms=[ALGORITHM])
    except jwt.ExpiredSignatureError as err:
        decoded = jwt.decode(token, SECRET, algorithms=[ALGORITHM], verify=False)
    return decoded["username"]

def decode_token(token: str):
    decoded = None
    try:
        decoded = jwt.decode(token,SECRET,algorithms=[ALGORITHM])
    except jwt.ExpiredSignatureError as err:
        decoded = jwt.decode(token, SECRET, algorithms=[ALGORITHM], verify=False)
    return decoded


def get_jwt(user: User):
    external_token = user.external_token if user.external_token else ''
    # print('external token for user {}: {}'.format(str(user), external_token))
    return jwt.encode({'username': user.email, 'exp': datetime.now()+TOKEN_EXPIRY, 'external_token': external_token}, SECRET, algorithm=ALGORITHM)
