from typing import List, Optional
from pydantic import BaseModel

class UserBase(BaseModel):
    email: str
    roles: Optional[str] = None
    github_username: Optional[str] = None
    github_org: Optional[str] = None

class UserCreate(UserBase):
    password: str

class UserDelete(UserBase):
    id: Optional[int]


class User(UserBase):
    id: int
    external_token: Optional[str] = None
    class Config:
        orm_mode = True


class LoginParams(UserBase):
    password: str