import { NgModule } from '@angular/core';
import { Routes, RouterModule } from '@angular/router';

import { HomeComponent } from './home/home.component';
import { ApplicationsComponent } from './applications/applications.component';
import { EnvironmentsComponent } from './environments/environments.component';
import { ConfigBuilderComponent } from './config-builder/config-builder.component';
import { DocsComponent } from './docs/docs.component';
import { LoginComponent } from './login/login.component';
import { AuthGuardService } from './services/authguard.service';
import { LoginErrorComponent } from './login-error/login-error.component';
import { AdminComponent } from './admin/admin.component';
import { CompTemplateComponent } from './comp-templates/comp-template.component';
 

const routes: Routes = [
  
  {path: 'home', component: HomeComponent, canActivate: [AuthGuardService]},
  {path: 'docs', component:DocsComponent,  canActivate: [AuthGuardService] },
  {path: 'applications', component: ApplicationsComponent, canActivate: [AuthGuardService]},
  {path: 'environments', component: EnvironmentsComponent, canActivate: [AuthGuardService]},
  {path: 'config-builder', component: ConfigBuilderComponent, canActivate: [AuthGuardService]},
  {path: 'login_error', component: LoginErrorComponent},
  {path: 'login', component: LoginComponent},
  {path: 'admin', component: AdminComponent},
  {path: 'comp-templates', component: CompTemplateComponent},
  {path: '', redirectTo: '/home', pathMatch: 'full'},
  {path: '**', redirectTo: '/home'}

];

@NgModule({
  imports: [RouterModule.forRoot(routes)],
  exports: [RouterModule]
})
export class AppRoutingModule { }
