import { Component, OnInit, Input, OnDestroy } from '@angular/core';
import {AppDialogComponent} from '../app-dialog/app-dialog.component';
import {MatDialog, MatDialogRef, MAT_DIALOG_DATA} from '@angular/material/dialog';
import { ActivatedRoute, Router } from '@angular/router';
import {GeneralService} from '../../services/general.service';


@Component({
  selector: 'app-selector',
  templateUrl: './app-selector.component.html',
  styleUrls: ['./app-selector.component.css']
})
export class AppSelectorComponent implements OnInit {
  @Input() appName:String; 
  @Input() envLength:number;

  constructor(private generalService: GeneralService,
    public dialog: MatDialog,
    private route: ActivatedRoute,
    private router:Router) {}

  ngOnInit(): void {
  }

  // addQueryParameters() {
   
  //   //this.removeQueryParameters();

  //   this.router.navigate([], {
  //    queryParams: {
  //      app: this.appName,
  //    },
  //    queryParamsHandling: 'merge',
  //  });
  // }

  // removeQueryParameters() {
  //   this.router.navigate([], {
  //     queryParams: {
  //       app: null,
  //     },
  //     queryParamsHandling: 'merge'
  //   })
  // }

  openAppDialog(): void{
    //this.addQueryParameters();
    this.generalService.alterQueryParameters({
      app: this.appName,
    })
    const dialogRef = this.dialog.open(AppDialogComponent, 
      {
        width: '90%',
        height: '90%',
        data: {
          name:this.appName
        }
      }
    );

    dialogRef.afterClosed().subscribe(() => {
        //this.removeQueryParameters();
        this.generalService.alterQueryParameters({
              app: null,
            })
      }
    )
  }


}
