import { Component, OnInit, Inject } from '@angular/core';
import { MatSelectModule } from '@angular/material/select'
import { GithubService } from '../services/github.service';
import { HttpErrorResponse } from '@angular/common/http';
import { MatDialogRef, MAT_DIALOG_DATA } from '@angular/material/dialog';
import { FormControl, FormGroup } from '@angular/forms';

@Component({
  selector: 'app-commit-dialog',
  templateUrl: './commit-dialog.component.html',
  styleUrls: ['./commit-dialog.component.css']
})

export class CommitDialogComponent implements OnInit {

  public serviceError = false;
  public repos: string[];
  public errMsg: string;
  selectedRepo = new FormControl('')
  
  constructor(private githubService: GithubService,
    public dialogRef: MatDialogRef<CommitDialogComponent>,
    @Inject(MAT_DIALOG_DATA) public data) {
    
  }

  ngOnInit(): void {
    this.fetchRepos()
  }

  fetchRepos() {
    //TODO: make api call.
    this.serviceError = false;
    this.repos = [];
    this.githubService.getRepos().subscribe((data: Object[])  => {
      data.forEach(element => {
        this.repos.push(element['name'])
      });
    },
      (err: HttpErrorResponse) => {
        this.serviceError = true;
        this.errMsg = "Unable to fetch repos";
      });


  }

  commit() {
    this.githubService.commitFile(this.selectedRepo.value, this.data['filename'], 'master', this.data['file']).subscribe(
      data => {
        this.dialogRef.close('');
      },
      (err: HttpErrorResponse) => {
        this.serviceError;
        this.errMsg = this.errMsg = "Unable to push file to repo";
      });
  }

}
