import {MediaMatcher} from '@angular/cdk/layout';
import {ChangeDetectorRef, Component, OnDestroy} from '@angular/core';
import { InfoDialogComponent } from '../info-dialog/info-dialog.component';
import { MatDialog } from '@angular/material/dialog';
import { Title } from '@angular/platform-browser';

/** @title Responsive sidenav */
@Component({
  selector: 'home',
  templateUrl: 'home.component.html',
  styleUrls: ['home.component.css'],
})
export class HomeComponent implements OnDestroy {
  mobileQuery: MediaQueryList;
//   fillerNav: { id: string, path: string }[] = [
//     { "id": 'Applications', "path": "/Applications" },
//     { "id": 'Environments', "path": "/Environments" },
//     { "id": 'Documentation', "path": "/Documentation" }
// ]
  //fillerNav = Array.from({length: 50}, (_, i) => `Nav Item ${i + 1}`);

  infoDialog:string = 
  "<p>"+
      "The landing page of the f8 UI."+
  "<p>";
  


  private _mobileQueryListener: () => void;

  constructor(changeDetectorRef: ChangeDetectorRef,
    media: MediaMatcher,
    public dialog: MatDialog,
    private titleService: Title)
  {
    titleService.setTitle('Home');
    this.mobileQuery = media.matchMedia('(max-width: 600px)');
    this._mobileQueryListener = () => changeDetectorRef.detectChanges();
    this.mobileQuery.addListener(this._mobileQueryListener);
  }

  ngOnDestroy(): void {
    this.mobileQuery.removeListener(this._mobileQueryListener);
  }


  openInfoDialog(): void{
    const dialogRef = this.dialog.open(InfoDialogComponent, 
      {
      width: '40%',
      height: '40%',
      data: {
        type:"home",
        text:this.infoDialog
      }
      }
    );
  }

}

