import { Injectable } from '@angular/core';
import { HttpClient } from '@angular/common/http';
import {GeneralService} from '../services/general.service';
import { timeout, catchError } from 'rxjs/operators';
import { of } from 'rxjs';
import { Globals } from '../global'


@Injectable({
  providedIn: 'root'
})
export class ApplicationsService {
  
  constructor(private generalService: GeneralService,
    private http: HttpClient, 
    private global: Globals) {} 

  //api/applications?name=' + $scope.app_name + '&repoUrl=' + $scope.source_repo_url

  getEnvs(){
    var APP_URL:string;
    APP_URL = 'api/environments?shallow=true';
    return this.http.get(APP_URL).pipe(timeout(20000))
  }

  getAppEnvs(appName:string){
   var ENV_URL:string;
   ENV_URL = 'api/environments?'+
   'shallow=true&app='+appName;
   return this.http.get(ENV_URL).pipe(timeout(20000));
  }

  createApp(appName:string, repoURL:string){
    var CREATE_APP_URL:string;
    CREATE_APP_URL = 'api/applications?name=' + appName + '&repoUrl=' + repoURL;
    //TODO: NEED TO CHANGE THIS BACK TO HOST URL EVENTUALLY. 
    //CREATE_APP_URL = 'https://f8-demo.aramse.io/api/applications?name=' + appName + '&repoUrl=' + repoURL;
    return this.http.post(CREATE_APP_URL,null).pipe(timeout(20000));
  }

  getAppDetails(appName:string, envName:string){
    var APP_URL_DETAILED:string;
   APP_URL_DETAILED = 'api/environments?'+
   '&app='+appName+'&name='+envName;
   return this.http.get(APP_URL_DETAILED).pipe(timeout(20000));
  }
  
}
