import { Injectable } from '@angular/core';
import { HttpClient } from '@angular/common/http';
import { Globals } from '../global'
import { timeout } from 'rxjs/operators';

@Injectable({
  providedIn: 'root'
})
export class CompTemplatesService {

  constructor(private http: HttpClient,
    private global: Globals) { }

  getCompTemplate(templateName:string) {
    var COMP_TEMPLATES_URL:string;
    COMP_TEMPLATES_URL = 'api/comp-template?name=' + templateName;
    return this.http.get(COMP_TEMPLATES_URL).pipe(timeout(10000));
  }

  getCompTemplateVarsSchema(templateName:string) {
    var COMP_TEMPLATES_URL:string;
    COMP_TEMPLATES_URL = 'api/comp-template-vars-schema?name=' + templateName;
    return this.http.get(COMP_TEMPLATES_URL).pipe(timeout(10000));
  }
}
