import { Injectable } from '@angular/core';
import { HttpClient } from '@angular/common/http';
import { Globals } from '../global';
import { timeout } from 'rxjs/operators';

@Injectable({
  providedIn: 'root'
})
export class ConfigBuilderService {

  constructor(private http: HttpClient, 
    private global: Globals) { }

  getSchemas() {
    var SCHEMA_URL:string;
    SCHEMA_URL = 'api/schema';
    return this.http.get(SCHEMA_URL).pipe(timeout(20000));
  }

  validateWithServer(value:any){
    var VALIDATE_URL:string;
    VALIDATE_URL ='api/validate';
    return this.http.post(VALIDATE_URL,value).pipe(timeout(20000));
  }

  initConfig(source_repo_url, source_repo_ref, app_name){
    var INIT_URL:string;
    INIT_URL = 'api/init?repo=' + source_repo_url + '&ref=' + source_repo_ref + '&name=' + app_name;
    return this.http.get(INIT_URL).pipe(timeout(20000));
  }

  resolveEnvironmentType(env_type_name, include_globals, raw_config_value){
    var RESOLVE_URL:string;
    RESOLVE_URL = 'api/resolve?env_type=' + env_type_name + '&include_globals=' + include_globals;
    return this.http.post(RESOLVE_URL, raw_config_value).pipe(timeout(20000));
  }
}
