import { Injectable } from '@angular/core';
import { HttpClient, HttpRequest, HttpHeaders } from '@angular/common/http';
import { Globals } from '../global';
import { timeout } from 'rxjs/operators';
import { takeUntil } from 'rxjs/operators';
import { Subject } from 'rxjs';

@Injectable({
  providedIn: 'root'
})
export class EnvironmentsService {
  
  protected ngUnsubscribe: Subject<void> = new Subject<void>();

  constructor(public http: HttpClient, 
    private global: Globals) { }

  getEnvironmentDetails(selected_service, selected_env, selected_cluster){
    var DETAILS_URL:string;
    
    DETAILS_URL = 'api/environments?expected_count=1&app=' + selected_service 
                    + '&name=' + selected_env 
                    + '&cluster=' + selected_cluster
    return this.http.get(DETAILS_URL).pipe(timeout(20000));
  }

  // TO-DO: put this to use
  getEnvironmentList() {
    var LIST_URL:string;
    LIST_URL = 'api/environments?shallow=true';
    return this.http.get(LIST_URL).pipe(timeout(20000));
  };

  getSchemas() {
    var SCHEMA_URL:string;
    SCHEMA_URL = 'api/schema';
    return this.http.get(SCHEMA_URL).pipe(timeout(20000));
  }

  
  getEnvironmentLogs(service:string, env_name:string, log_instances:string[], selected_cluster:string, logs_since_seconds, log_timestamps, comps:string[]) {
    var LOGS_URL:string;
    LOGS_URL = 'api/logs?html=true&limit_bytes=4000000&app=' +
    service + '&env_name=' + env_name + '&instances=' + log_instances.join() + '&comps=' + comps.join() + '&cluster=' + selected_cluster;
    if (parseInt(logs_since_seconds)) LOGS_URL += '&since_seconds=' + logs_since_seconds;
    if (log_timestamps) LOGS_URL += '&timestamps=true';
    
    const req = new HttpRequest('GET', LOGS_URL, {
      reportProgress: true,
      responseType: 'text'
    });

    return this.http.request(req);
    //return this.http.get(LOGS_URL)
  }


  ngOnDestroy(){

  }


}
