import { Injectable } from '@angular/core';
import { HttpClient, HttpParams } from '@angular/common/http';

@Injectable({
  providedIn: 'root'
})
export class GithubService {

  constructor(private http: HttpClient) { }


  getRepos() {
    const url = `api/userRepos`
    return this.http.get<any[]>(url);
  }

  getBranches(repo :string ) {
    const url = `api/repoBranches`;
    let params = new HttpParams();
    params = params.set("repo",repo )
    return this.http.get<any[]>(url, {params: params});
  }

  getFile(repo: string, branch : string, filename: string) {
    const url = `api/githubFile`;
    let params = new HttpParams()
              .set("repo",repo )
              .set("branch", branch)
              .set("filename", filename);
    return this.http.get<any[]>(url, {params: params});
  }


  commitFile(repo : string, branch: string, filename : string, content :string) {

    const data = {
      repo: repo,
      branch: branch,
      filename: filename,
      content: btoa(content)
    }
    return this.http.post<Object[]>('api/githubFile', data)
  }
}
