import { Component, OnInit, Input } from '@angular/core';
import { AuthService } from '../services/auth.service';
import { Router } from '@angular/router';

@Component({
  selector: 'app-sidenav',
  templateUrl: './sidenav.component.html',
  styleUrls: ['./sidenav.component.css']
})
export class SidenavComponent implements OnInit {
  @Input() sNav;
  isAdmin: boolean;

  constructor(private authService : AuthService, private router : Router) { }

  async ngOnInit() {
    this.isAdmin = false;
    this.isAdmin = await this.authService.isAdmin().toPromise();
  }

  logout(){
    this.authService.logout();
    this.router.navigateByUrl('/login');
  }


}
